#ifndef __ARCH_IA32_IO__
#define __ARCH_IA32_IO__

#ifndef __ASM__

#define cli() asm volatile("cli")
#define sti() asm volatile("sti")

/* INPUT: Non-pausing */
u_int8_t inb (u_int32_t port);
u_int16_t inw (u_int32_t port);
u_int32_t inl (u_int32_t port);

/* INPUT: Pausing */
u_int8_t inb_p (u_int32_t port);

/* OUTPUT: Non-pausing */
void outb(u_int32_t port, u_int8_t val);
void outw(u_int32_t port, u_int16_t val);
void outl(u_int32_t port, u_int32_t val);

/* OUTPUT: Pausing */
void outb_p (u_int32_t port, u_int8_t val);
void outw_p (u_int32_t port, u_int16_t val);
#endif

#endif /* __ARCH_IA32_IO__ */
